/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.micode.notes.gtask.data;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;
// 导入Notes类，包含Notes的列和数据常量
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
// 导入NotesDatabaseHelper类，包含Notes的表
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
// 导入ActionFailureException类，用于处理操作失败异常
import net.micode.notes.gtask.exception.ActionFailureException;
// 导入JSON相关的类，用于处理JSON数据
import org.json.JSONException;
import org.json.JSONObject;
public class SqlData {
    // 定义一个常量，用于标识无效的ID
    private static final String TAG = SqlData.class.getSimpleName();

    private static final int INVALID_ID = -99999;

    // 定义一个常量，用于存储数据的列名
    public static final String[] PROJECTION_DATA = new String[] {
            DataColumns.ID, DataColumns.MIME_TYPE, DataColumns.CONTENT, DataColumns.DATA1,
            DataColumns.DATA3
    };

    public static final int DATA_ID_COLUMN = 0; // 数据ID列

    public static final int DATA_MIME_TYPE_COLUMN = 1; // 数据MIME类型列

    public static final int DATA_CONTENT_COLUMN = 2; // 数据内容列

    public static final int DATA_CONTENT_DATA_1_COLUMN = 3; // 数据内容数据1列

    public static final int DATA_CONTENT_DATA_3_COLUMN = 4; // 数据内容数据3列

    private ContentResolver mContentResolver; // 内容解析器

    private boolean mIsCreate; // 是否创建

    private long mDataId; // 数据ID

    private String mDataMimeType; // 数据MIME类型

    private String mDataContent; // 数据内容

    private long mDataContentData1; // 数据内容数据1

    private String mDataContentData3; // 数据内容数据3

    private ContentValues mDiffDataValues; // 数据值

// 构造函数，初始化SqlData对象
    public SqlData(Context context) {
        // 获取ContentResolver对象
        mContentResolver = context.getContentResolver();
        // 标记为创建状态
        mIsCreate = true;
        // 初始化数据ID为无效ID
        mDataId = INVALID_ID;
        // 初始化数据类型为NOTE
        mDataMimeType = DataConstants.NOTE;
        // 初始化数据内容为空字符串
        mDataContent = "";
        // 初始化数据内容数据1为0
        mDataContentData1 = 0;
        // 初始化数据内容数据3为空字符串
        mDataContentData3 = "";
        // 初始化ContentValues对象
        mDiffDataValues = new ContentValues();
    }

    // 构造函数，用于从Cursor中加载数据
    public SqlData(Context context, Cursor c) {
        // 获取ContentResolver
        mContentResolver = context.getContentResolver();
        // 设置mIsCreate为false
        mIsCreate = false;
        // 从Cursor中加载数据
        loadFromCursor(c);
        // 初始化mDiffDataValues
        mDiffDataValues = new ContentValues();
    }

// 从游标中加载数据
    private void loadFromCursor(Cursor c) {
        // 从游标中获取数据ID
        mDataId = c.getLong(DATA_ID_COLUMN);
        // 从游标中获取数据MIME类型
        mDataMimeType = c.getString(DATA_MIME_TYPE_COLUMN);
        // 从游标中获取数据内容
        mDataContent = c.getString(DATA_CONTENT_COLUMN);
        // 从游标中获取数据内容数据1
        mDataContentData1 = c.getLong(DATA_CONTENT_DATA_1_COLUMN);
        // 从游标中获取数据内容数据3
        mDataContentData3 = c.getString(DATA_CONTENT_DATA_3_COLUMN);
    }

  // 设置内容
    public void setContent(JSONObject js) throws JSONException {
        // 获取数据ID
        long dataId = js.has(DataColumns.ID) ? js.getLong(DataColumns.ID) : INVALID_ID;
        // 如果是创建状态或者数据ID不一致，则将数据ID放入差异数据中
        if (mIsCreate || mDataId != dataId) {
            mDiffDataValues.put(DataColumns.ID, dataId);
        }
        // 更新数据ID
        mDataId = dataId;

 // 获取数据类型
        String dataMimeType = js.has(DataColumns.MIME_TYPE) ? js.getString(DataColumns.MIME_TYPE)
                : DataConstants.NOTE;
 // 如果是创建或者数据类型不同，则将数据类型放入差异值中
        if (mIsCreate || !mDataMimeType.equals(dataMimeType)) {
            mDiffDataValues.put(DataColumns.MIME_TYPE, dataMimeType);
        }
 // 更新数据类型
        mDataMimeType = dataMimeType;

 // 获取数据内容
        String dataContent = js.has(DataColumns.CONTENT) ? js.getString(DataColumns.CONTENT) : "";
 // 如果是创建或者数据内容不同，则将数据内容放入差异值中
        if (mIsCreate || !mDataContent.equals(dataContent)) {
            mDiffDataValues.put(DataColumns.CONTENT, dataContent);
        }
 // 更新数据内容
        mDataContent = dataContent;

        // 获取js中DATA1字段的值，如果没有则赋值为0
        long dataContentData1 = js.has(DataColumns.DATA1) ? js.getLong(DataColumns.DATA1) : 0;
        // 如果是创建或者mDataContentData1的值与dataContentData1的值不相等，则将dataContentData1的值放入mDiffDataValues中
        if (mIsCreate || mDataContentData1 != dataContentData1) {
            mDiffDataValues.put(DataColumns.DATA1, dataContentData1);
        }
        // 将dataContentData1的值赋给mDataContentData1
        mDataContentData1 = dataContentData1;

        // 获取js中DATA3字段的值，如果没有则赋值为空字符串
        String dataContentData3 = js.has(DataColumns.DATA3) ? js.getString(DataColumns.DATA3) : "";
        // 如果是创建或者mDataContentData3的值与dataContentData3的值不相等，则将dataContentData3的值放入mDiffDataValues中
        if (mIsCreate || !mDataContentData3.equals(dataContentData3)) {
            mDiffDataValues.put(DataColumns.DATA3, dataContentData3);
        }
        // 将dataContentData3的值赋给mDataContentData3
        mDataContentData3 = dataContentData3;
    }

    public JSONObject getContent() throws JSONException {
        // 如果mIsCreate为true，说明还没有在数据库中创建
        if (mIsCreate) {
            Log.e(TAG, "it seems that we haven't created this in database yet");
            return null;
        }
        // 创建一个JSONObject对象
        JSONObject js = new JSONObject();
        // 将mDataId放入JSONObject中
        js.put(DataColumns.ID, mDataId);
        // 将mDataMimeType放入JSONObject中
        js.put(DataColumns.MIME_TYPE, mDataMimeType);
        // 将mDataContent放入JSONObject中
        js.put(DataColumns.CONTENT, mDataContent);
        // 将mDataContentData1放入JSONObject中
        js.put(DataColumns.DATA1, mDataContentData1);
        // 将mDataContentData3放入JSONObject中
        js.put(DataColumns.DATA3, mDataContentData3);
        // 返回JSONObject对象
        return js;
    }

    public void commit(long noteId, boolean validateVersion, long version) {

        // 如果是创建操作
        if (mIsCreate) {
            // 如果数据ID无效且数据值中包含ID列
            if (mDataId == INVALID_ID && mDiffDataValues.containsKey(DataColumns.ID)) {
                // 移除ID列
                mDiffDataValues.remove(DataColumns.ID);
            }

            // 将noteId放入数据值中
            mDiffDataValues.put(DataColumns.NOTE_ID, noteId);
            // 插入数据
            Uri uri = mContentResolver.insert(Notes.CONTENT_DATA_URI, mDiffDataValues);
            try {
                // 获取插入数据的ID
                mDataId = Long.valueOf(uri.getPathSegments().get(1));
            } catch (NumberFormatException e) {
                // 如果获取ID失败，打印错误日志并抛出异常
                Log.e(TAG, "Get note id error :" + e.toString());
                throw new ActionFailureException("create note failed");
            }
        } else {
            // 如果mDiffDataValues的大小大于0
            if (mDiffDataValues.size() > 0) {
                int result = 0;
                // 如果validateVersion为false
                if (!validateVersion) {
                    // 更新mContentResolver中的数据
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues, null, null);
                } else {
                    // 更新mContentResolver中的数据，并添加验证版本号的条件
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues,
                            " ? in (SELECT " + NoteColumns.ID + " FROM " + TABLE.NOTE
                                    + " WHERE " + NoteColumns.VERSION + "=?)", new String[] {
                                    String.valueOf(noteId), String.valueOf(version)
                            });
                }
                // 如果更新结果为0
                if (result == 0) {
                    // 打印警告日志
                    Log.w(TAG, "there is no update. maybe user updates note when syncing");
                }
            }
        }

    // 清空mDiffDataValues
        mDiffDataValues.clear();
    // 将mIsCreate设置为false
        mIsCreate = false;
    }

// 获取mDataId的值
    public long getId() {
        return mDataId;
    }
}
